%define anolis_release 2

%global pypi_name cloudpickle
%global desc cloudpickle makes it possible to serialize Python constructs \
not supported by the default pickle module from the Python standard \
library. cloudpickle is especially useful for cluster computing where \
Python expressions are shipped over the network to execute on remote \
hosts, possibly close to the data. Among other things, cloudpickle \
supports pickling for lambda expressions, functions and classes defined \
interactively in the __main__ module.

Name:           python-%{pypi_name}
Version:        2.2.1
Release:        %{anolis_release}%{dist}

Summary:        Extended pickling support for Python objects

License:        BSD
URL:            https://github.com/cloudpipe/cloudpickle
Source0:        https://files.pythonhosted.org/packages/source/c/%{pypi_name}/%{pypi_name}-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  %{py3_dist setuptools}

# Test requirements
BuildRequires:  %{py3_dist pytest tornado psutil}

%description
%{desc}

%package -n     python3-%{pypi_name}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{pypi_name}}

%description -n python3-%{pypi_name}
%{desc}

%package -n python3-%{pypi_name}-doc
Summary:        Documentation files for %{name}
Requires:       python3-%{pypi_name} = %{EVR}
BuildArch:      noarch

%description -n python3-%{pypi_name}-doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{pypi_name}-%{version}
rm -rf %{pypi_name}.egg-info

# Simple backport of https://github.com/cloudpipe/cloudpickle/pull/475
# to make tests pass with Python 3.11b3
sed -i "s/'beta', 2/'beta', 4/" tests/cloudpickle_test.py

%build
%py3_build

%install
%py3_install

%check
# file_handles tests fail, TypeError: cannot pickle '_io.FileIO' object
# GH issue: https://github.com/cloudpipe/cloudpickle/issues/114
# test_dynamic_pytest_module uses py which is not longer part of pytest
# https://github.com/cloudpipe/cloudpickle/issues/487
PYTHONPATH=tests/cloudpickle_testpkg %{__python3} -m pytest -v -k "not file_handles and not test_dynamic_pytest_module"

%generate_compatibility_deps

%files -n python3-%{pypi_name}
%license LICENSE
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%files -n python3-%{pypi_name}-doc
%doc README.md

%changelog
* Fri Mar 15 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 2.2.1-2
- Rebuild with python3.11

* Tue Mar 28 2023 yuanhui <yuanhui@linux.alibaba.com> - 2.2.1-1
- Init package from upstream
